unit Unit_SAO;


interface

uses
     Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     StdCtrls, Menus,printers;
procedure loadbuffer(naam1:string);
procedure read_SAO(epoch2:real;var ra1,dec1: real; var mag1,nr_star,spectral: integer);

implementation
uses dat_main;
FUNCTION SPECTRUM(ING:STRING):BYTE;
var
  out   :byte;
begin
 out:=0;
 case ing[1] of
             'O': out:=out+0*16;
             'B': out:=out+1*16;
             'A': out:=out+2*16;
             'F': out:=out+3*16;
             'G': out:=out+4*16;
             'K': out:=out+5*16;
             'M': out:=out+6*16;
             'R': out:=out+7*16;
             'N': out:=out+8*16;
             'S': out:=out+9*16;
             'C': out:=out+10*16;
             'W': out:=out+11*16;
             'P': out:=out+12*16;
{            '?': out:=out+13*16;}
             '+': out:=out+14*16;
             ' ': out:=out+15*16;
             else
               begin
                 out:=out+15*16; {blanco}
                 writeln('not found first spectrum letter:',ing[1]);
              {   halt;}
               end;
             end;{case}
 case ing[2] of
             '0': out:=out+0;
             '1': out:=out+1;
             '2': out:=out+2;
             '3': out:=out+3;
             '4': out:=out+4;
             '5': out:=out+5;
             '6': out:=out+6;
             '7': out:=out+7;
             '8': out:=out+8;
             '9': out:=out+9;
             'A': out:=out+10;
             'B': out:=out+11;
             'C': out:=out+12;
             'E': out:=out+13;
             '+': out:=out+14;
             ' ': out:=out+15;
             else
               begin
                  out:=out+15; {blanco}
{                 writeln('not found second spectrum letter :',ing[2]);}
{                 stop;      }
             end;
             end;
  spectrum:=out;
end;

procedure loadbuffer(naam1:string);
begin
 with bufferstring1 do
 begin
   try
     LoadFromFile(naam1);	{ load from file }
   except;
    {action none}
     clear;
     beep;
     form1.caption:='Error reading file: '+naam1;
   end;
 end;
 readposition:=0;
end;

procedure read_SAO(epoch2:real;var ra1,dec1: real; var mag1,nr_star,spectral: integer);  {note byte als in parameter of sortSAO wgeeft fouten, daarom spectral is integer}
var
   info  : string;
   error1,error_total:integer;
   mag1r,pmRA, pmDEC,hour,min,sec,
   decx                              : real;
   star_ok: boolean;
begin
  repeat
    if copy(bufferstring1.strings[readposition],8,1)=' ' then {good star}
    begin
      error_total:=0;

      {Right accension seperate hr min sec mode========}
      info:=copy(bufferstring1.strings[readposition],65,2);
       val(info,hour,error1);error_total:=error_total+error1;
      info:=copy(bufferstring1.strings[readposition],68,2);
      val(info,min,error1);error_total:=error_total+error1;
      info:=copy(bufferstring1.strings[readposition],71,6);
      val(info,sec,error1);  error_total:=error_total+error1;
      ra1:=(hour+min/60+sec/3600)*360/24;{degrees}

       {declination===========================================}
      decx:=0;
      {Declination degrees min sec mode========}
      info:=copy(bufferstring1.strings[readposition],79,2);
      val(info,decx,error1); error_total:=error_total+error1;
      decx:=(decx);{dergees}
      info:=copy(bufferstring1.strings[readposition],82,2);
      val(info,min,error1);error_total:=error_total+error1;
      decx:=decx+(min/60);
      info:=copy(bufferstring1.strings[readposition],85,5);
      val(info,sec,error1);error_total:=error_total+error1;
      decx:=decx+(sec/3600);{degrees}

      if copy(bufferstring1.strings[readposition],78,1)='-' then decx:=-decx;
      dec1:=decx;


      info:=copy(bufferstring1.strings[readposition],1,6);{star number}
      val(info,nr_star,error1);error_total:=error_total+error1;

//      if nr_star=431 then
//      beep;

      info:=copy(bufferstring1.strings[readposition],23,7);{pmRA, proper motion RA}
      val(info,pmRA,error1);
      pmRa:=pmRA*15*1000; {conversion from RA seconds x15 to milliarcseconds x1000}
      info:=copy(bufferstring1.strings[readposition],44,6);{pmDEC}
      val(info,pmDEC,error1);error_total:=error_total+error1;
      pmDEC:=pmDEC*1000; {conversion from arc seconds to milliarcseconds}

      info:=copy(bufferstring1.strings[readposition],56,4); {V magnitude}
      val(info,mag1r,error1);error_total:=error_total+error1;
      mag1:=round(mag1r*10);

      info:=copy(bufferstring1.strings[readposition],61,2);
      Spectral:=spectrum(info);

      if error_total<>0 then mag1:=999 {ignore this star entry, try next }
      else
      begin
        DEC1 {(epoch T)} := (DEC1 + pmDEC * (epoch2 - 2000.0)/(3600*1000))*  (pi/180);  {DEC first, pmDEC in mas}
        RA1  {(epoch T)} := (RA1  + pmRA {/ cos(dec1)}*(epoch2 - 2000.0)/(3600*1000))*(pi/180);{no cosinus correction for SAO}
        {now radians}
      end;
      star_ok:=((mag1>round(mag_begin*10))  and  (mag1<=round((mag_begin+step)*10))) {magnitude filter, round function to get sharp selection and not star is forgotten or double processec}
    end
    else
    star_ok:=false;
    inc(readposition);
  until ((readposition>=bufferstring1.count) or  (star_ok));
  if star_ok=false then mag1:=1000;{last star is not okay to include in this run}
end;

begin  {program}
end.